/**
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { ChangeDetectorRef, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { NzConfigKey, NzConfigService } from 'ng-zorro-antd/core/config';
import { BooleanInput } from 'ng-zorro-antd/core/types';
import { NzDropdownMenuComponent } from 'ng-zorro-antd/dropdown';
export declare class NzFilterTriggerComponent implements OnChanges {
    readonly nzConfigService: NzConfigService;
    private cdr;
    readonly _nzModuleName: NzConfigKey;
    static ngAcceptInputType_nzBackdrop: BooleanInput;
    static ngAcceptInputType_nzHasBackdrop: BooleanInput;
    nzActive: boolean;
    nzDropdownMenu: NzDropdownMenuComponent;
    nzVisible: boolean;
    /**
     * @deprecated Not supported, use `nzBackdrop` instead.
     * @breaking-change 13.0.0
     */
    nzHasBackdrop: boolean;
    nzBackdrop: boolean;
    readonly nzVisibleChange: EventEmitter<boolean>;
    onVisibleChange(visible: boolean): void;
    onFilterClick($event: MouseEvent): void;
    hide(): void;
    show(): void;
    constructor(nzConfigService: NzConfigService, cdr: ChangeDetectorRef);
    ngOnChanges(changes: SimpleChanges): void;
}
